Lattice Grid Buy a licence

demo D24

Units

Bytes, distances and rates, parsed in the unit the user typed

createUnitType()

Building…
Loading a live grid…

The configuration

import * as ng from '@angular/core';
import { Component } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid, createUnitType } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import createLatticeGrid from '@toclocoinc/lattice-grid/modules/angular';

const { LatticeGridComponent } = createLatticeGrid({ ng, createGrid });

// Three unit systems, each one a call. display: 'auto' walks the ladder per
// value, so a 900 MB row and a 4 TB row are both readable in the same column
// without either losing its precision.
const dataTypes = {
  binaryBytes: createUnitType({ system: 'data', unit: 'B', display: 'auto', binary: true, decimals: 1 }),
  siBytes: createUnitType({ system: 'data', unit: 'B', display: 'auto', decimals: 1 }),
  fixedGiB: createUnitType({ system: 'data', unit: 'B', display: 'GiB', decimals: 2 }),
  rate: createUnitType({ system: 'bitrate', unit: 'bps', display: 'auto', decimals: 0 }),
  cable: createUnitType({ system: 'length', unit: 'm', display: 'auto', decimals: 1 }),
};

const columns = [
  { field: 'hostname', title: 'Hostname', layout: { width: 280, pin: 'start' } },
  { field: 'storageBytes', id: 'iec', title: 'Storage, IEC', type: 'binaryBytes', layout: { width: 150 }, total: 'sum' },
  { field: 'storageBytes', id: 'si', title: 'Storage, SI', type: 'siBytes', layout: { width: 150 } },
  // Same field again, pinned to one unit: what a column you compare down
  // rather than read across wants.
  { field: 'storageBytes', id: 'gib', title: 'Storage, GiB', type: 'fixedGiB', layout: { width: 150 } },
  { field: 'linkBps', title: 'Link rate', type: 'rate', layout: { width: 150 } },
  { field: 'cableMetres', title: 'Cable run', type: 'cable', layout: { width: 140 }, total: 'sum' },
  // The shipped types are the same call with the arguments filled in.
  { field: 'storageBytes', id: 'shipped', title: "type: 'bytes'", type: 'bytes', layout: { width: 150 } },
  { field: 'ports', title: 'Ports', type: 'number', layout: { width: 110 } },
];

const rows = [/* nodes, one storage figure per row */];



@Component({
  selector: 'app-root',
  standalone: true,
  imports: [LatticeGridComponent],
  template: '<lattice-grid [config]="grid" style="display:block;height:540px"></lattice-grid>',
})
export class AppComponent {
  grid = {
    rowKey: 'id',
    toolPanel: { side: 'left', panels: ['columns', 'filters', 'views', 'quick'],
          actions: ['undo', 'redo', 'export', 'restore', 'maximise'], exportName: 'lattice-demo' },
    dataTypes: dataTypes,
    columns: columns,
    rows: rows,
  };
}

bootstrapApplication(AppComponent);

Parsing and rendering unit-bearing values in a column

A JavaScript data grid that stores plain numbers loses information the moment a column actually means bytes, kilometres or requests per second: a user typing 1.5 GB or 40 km/h expects the grid to understand the unit as well as the number. Lattice Grid handles this with createUnitType(), which builds a column type from a set of unit definitions, a base unit to store values in, and the parsing rules mapping typed input to that base. A file-size column defined this way accepts 1.5 GB, 800 MB or a bare byte count on entry, stores everything internally as bytes, and displays each value back in whichever unit keeps the number readable, so a byte count in the millions renders as megabytes rather than a long string of digits.

A developer reaches for this whenever a column mixes magnitudes a single fixed format cannot cover, such as network throughput or distance travelled, where the smallest unit makes large values unreadable and the largest rounds small values to zero. Parsing resolves to the base unit once, on entry, so sorting and filtering operate on that consistent numeric value rather than the display string, and a column mixing 2 TB and 500 MB sorts correctly without a custom comparator. Rendering applies only to rows in the current virtualised viewport, so adding a unit type carries no cost for rows scrolled out of view.

How do you show file sizes or distances in a JavaScript data grid?

Define the column type with createUnitType(), supplying the units it should recognise and the base unit values are stored in. Lattice Grid parses typed input such as 1.5 GB or 40 km into that base unit, keeps sorting and filtering consistent against the stored value, and renders each cell back in whichever unit best fits its magnitude.

Lattice Grid Buy a licence

demo D24

Units

Bytes, distances and rates, parsed in the unit the user typed

createUnitType()

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.min.css">

<div id="grid"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid, createUnitType } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/react.esm.min.js';

  const LatticeGrid = createLatticeGrid({ React, createGrid });

  // Three unit systems, each one a call. display: 'auto' walks the ladder per
  // value, so a 900 MB row and a 4 TB row are both readable in the same column
  // without either losing its precision.
  const dataTypes = {
    binaryBytes: createUnitType({ system: 'data', unit: 'B', display: 'auto', binary: true, decimals: 1 }),
    siBytes: createUnitType({ system: 'data', unit: 'B', display: 'auto', decimals: 1 }),
    fixedGiB: createUnitType({ system: 'data', unit: 'B', display: 'GiB', decimals: 2 }),
    rate: createUnitType({ system: 'bitrate', unit: 'bps', display: 'auto', decimals: 0 }),
    cable: createUnitType({ system: 'length', unit: 'm', display: 'auto', decimals: 1 }),
  };

  const columns = [
    { field: 'hostname', title: 'Hostname', layout: { width: 280, pin: 'start' } },
    { field: 'storageBytes', id: 'iec', title: 'Storage, IEC', type: 'binaryBytes', layout: { width: 150 }, total: 'sum' },
    { field: 'storageBytes', id: 'si', title: 'Storage, SI', type: 'siBytes', layout: { width: 150 } },
    // Same field again, pinned to one unit: what a column you compare down
    // rather than read across wants.
    { field: 'storageBytes', id: 'gib', title: 'Storage, GiB', type: 'fixedGiB', layout: { width: 150 } },
    { field: 'linkBps', title: 'Link rate', type: 'rate', layout: { width: 150 } },
    { field: 'cableMetres', title: 'Cable run', type: 'cable', layout: { width: 140 }, total: 'sum' },
    // The shipped types are the same call with the arguments filled in.
    { field: 'storageBytes', id: 'shipped', title: "type: 'bytes'", type: 'bytes', layout: { width: 150 } },
    { field: 'ports', title: 'Ports', type: 'number', layout: { width: 110 } },
  ];

  const rows = [/* nodes, one storage figure per row */];

  function App() {
    return (
      <LatticeGrid
        rowKey="id"
        toolPanel={{ side: 'left', panels: ['columns', 'filters', 'views', 'quick'],
          actions: ['undo', 'redo', 'export', 'restore', 'maximise'], exportName: 'lattice-demo' }}
        dataTypes={dataTypes}
        columns={columns}
        rows={rows}
        style={{ height: '540px' }}
      />
    );
  }

  createRoot(document.getElementById('grid')).render(<App />);
</script>

Parsing and rendering unit-bearing values in a column

A JavaScript data grid that stores plain numbers loses information the moment a column actually means bytes, kilometres or requests per second: a user typing 1.5 GB or 40 km/h expects the grid to understand the unit as well as the number. Lattice Grid handles this with createUnitType(), which builds a column type from a set of unit definitions, a base unit to store values in, and the parsing rules mapping typed input to that base. A file-size column defined this way accepts 1.5 GB, 800 MB or a bare byte count on entry, stores everything internally as bytes, and displays each value back in whichever unit keeps the number readable, so a byte count in the millions renders as megabytes rather than a long string of digits.

A developer reaches for this whenever a column mixes magnitudes a single fixed format cannot cover, such as network throughput or distance travelled, where the smallest unit makes large values unreadable and the largest rounds small values to zero. Parsing resolves to the base unit once, on entry, so sorting and filtering operate on that consistent numeric value rather than the display string, and a column mixing 2 TB and 500 MB sorts correctly without a custom comparator. Rendering applies only to rows in the current virtualised viewport, so adding a unit type carries no cost for rows scrolled out of view.

How do you show file sizes or distances in a JavaScript data grid?

Define the column type with createUnitType(), supplying the units it should recognise and the base unit values are stored in. Lattice Grid parses typed input such as 1.5 GB or 40 km into that base unit, keeps sorting and filtering consistent against the stored value, and renders each cell back in whichever unit best fits its magnitude.